## org.biojava.bio.program.gff
Class GFFTools

    java.lang.Object
      org.biojava.bio.program.gff.GFFTools

public class GFFTools
extends java.lang.Object

Since:
  1.2
Author:
  Mark Schreiber, Matthew Pocock

Field Summary
`static int` `NO_FRAME` Flag to indicate that there is no frame info.
`static double` `NO_SCORE` Flag to indicate that there is no score info.

Constructor Summary
`GFFTools()`

Method Summary
`static Sequence` `annotateSequence(Sequence seq, GFFEntrySet ents)` Annotates a sequence with the features from a GFF entry set with sequence name matching this sequence.
`static Sequence` `annotateSequence(Sequence seq, GFFEntrySet ents, boolean checkSeqName)` Annotates a sequence with the features from a GFF entry set.
`static SequenceDB` `annotateSequences(SequenceDB seqs, GFFEntrySet ents)` Annotates all sequences in a sequence DB with features from a GFF entry set.
`static GFFEntrySet` `gffFromSequence(Sequence seq)` Creates a GFFEntrySet containing one entry for each feature on a sequence.
`static GFFEntrySet` `readGFF(java.io.BufferedReader gffIn)`
`static GFFEntrySet` `readGFF(java.io.BufferedReader gffIn, GFFRecordFilter recFilt)`
`static GFFEntrySet` `readGFF(java.lang.String fileName)` Reads a `GFFEntrySet` from a file with no filtering
`static GFFEntrySet` `readGFF(java.lang.String fileName, GFFRecordFilter recFilt)` Reads a GFFEntrySet from a file with the specified filter
`static void` `writeGFF(java.io.PrintWriter pw, GFFEntrySet ents)` Writes a GFFEntrySet to a PrintWriter
`static void` `writeGFF(java.lang.String fileName, GFFEntrySet ents)` Writes a GFFEntrySet to a file

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NO_SCORE

    public static double NO_SCORE

  Flag to indicate that there is no score info.

### NO_FRAME

    public static int NO_FRAME

  Flag to indicate that there is no frame info.

Constructor Detail

### GFFTools

    public GFFTools()

Method Detail

### readGFF

    public static GFFEntrySet readGFF(java.lang.String fileName)
                               throws java.io.FileNotFoundException,
                                      ParserException,
                                      BioException,
                                      java.io.IOException

  Reads a `GFFEntrySet` from a file with no filtering

  Parameters:
    `fileName` - the file containing the GFF
  Returns:
    a `GFFEntrySet` encapsulating the records read from the file
  Throws:
    `java.io.FileNotFoundException` - if file is not found
    `ParserException` - if format is wrong
    `BioException` - if format is wrong
    `java.io.IOException` - if file reading error occurs

### readGFF

    public static GFFEntrySet readGFF(java.lang.String fileName,
                                      GFFRecordFilter recFilt)
                               throws java.io.FileNotFoundException,
                                      ParserException,
                                      BioException,
                                      java.io.IOException

  Reads a GFFEntrySet from a file with the specified filter

  Parameters:
    `fileName` - the file containing the GFF
    `recFilt` - the filter to use
  Returns:
    a `GFFEntrySet` encapsulating the records read from the file
  Throws:
    `java.io.FileNotFoundException` - if file is not found
    `ParserException` - if format is wrong
    `BioException` - if format is wrong
    `java.io.IOException` - if file reading error occurs

### readGFF

    public static GFFEntrySet readGFF(java.io.BufferedReader gffIn)
                               throws ParserException,
                                      BioException,
                                      java.io.IOException

  Throws:
    `ParserException`
    `BioException`
    `java.io.IOException`

### readGFF

    public static GFFEntrySet readGFF(java.io.BufferedReader gffIn,
                                      GFFRecordFilter recFilt)
                               throws ParserException,
                                      BioException,
                                      java.io.IOException

  Throws:
    `ParserException`
    `BioException`
    `java.io.IOException`

### writeGFF

    public static void writeGFF(java.lang.String fileName,
                                GFFEntrySet ents)
                         throws java.io.IOException

  Writes a GFFEntrySet to a file

  Parameters:
    `fileName` - the file to write to
    `ents` - the entries to write
  Throws:
    `java.io.IOException` - if file writing fails

### writeGFF

    public static void writeGFF(java.io.PrintWriter pw,
                                GFFEntrySet ents)
                         throws java.io.IOException

  Writes a GFFEntrySet to a PrintWriter

  Parameters:
    `pw` - the PrintWriter to write to
    `ents` - the entries to write
  Throws:
    `java.io.IOException` - if file writing fails

### annotateSequence

    public static Sequence annotateSequence(Sequence seq,
                                            GFFEntrySet ents)

  Annotates a sequence with the features from a GFF entry set with sequence name matching this sequence.

  Parameters:
    `seq` - the `Sequence` to annotate.
    `ents` - the the GFF features to annotate it with.
  Returns:
    a reference to a newly annotated sequence.

### annotateSequence

    public static Sequence annotateSequence(Sequence seq,
                                            GFFEntrySet ents,
                                            boolean checkSeqName)

  Annotates a sequence with the features from a GFF entry set.

  Parameters:
    `seq` - the `Sequence` to annotate.
    `ents` - the the GFF features to annotate it with.
  Returns:
    a reference to a newly annotated sequence.

### annotateSequences

    public static SequenceDB annotateSequences(SequenceDB seqs,
                                               GFFEntrySet ents)
                                        throws IllegalIDException,
                                               BioException

  Annotates all sequences in a sequence DB with features from a GFF entry set.

  Parameters:
    `seqs` - the SequenceDB to annotate
    `ents` - the GFFEntrySet to annote with
  Returns:
    a SequenceDB with all the annotations on
  Throws:
    `IllegalIDException`
    `BioException`

### gffFromSequence

    public static GFFEntrySet gffFromSequence(Sequence seq)
                                       throws BioException

  Creates a GFFEntrySet containing one entry for each feature on a sequence.

  Parameters:
    `seq` - the Sequence to create features for
  Returns:
    a new GFFEntrySet with gff records for each featre on the sequence
  Throws:
    `BioException` - if something went wrong GFF-ifying the sequences features